<template lang="pug">
b-table( :columns='columns' :data='clients' :loading='loading' @click='emit("select", $event)' )
	template( #contacts='{ item }' )
		.content.is-marginless.is-small
			.block.is-marginless( v-if='item.phone' )
				.is-flex.is-align-items-center.is-justify-content-flex-start
					a( :href='`tel:${item.phone}`' ) {{item.phone}}
					.socials.ml-2( v-if='Object.keys(s(item.Messengers).main).length' )
						a.social( 
							v-for='(social, prop) in s(item.Messengers).main'
							target="_blank"
							:href='h(item.phone)[prop]' )
							span.icon.is-small
								i.fa-brands( :class='`fa-${prop}`' )
			template( v-if='item.extra_phone' )
				hr.my-1.has-background-light
				.block
					a( :href='`tel:${item.extra_phone}`' ) {{item.extra_phone}}
					.socials.ml-2( v-if='Object.keys(s(item.Messengers).extra).length' )
						a.social( 
							v-for='(social, prop) in s(item.Messengers).extra'
							target="_blank"
							:href='h(item.extra_phone)[prop]' )
							span.icon.is-small
								i.fa-brands( :class='`fa-${prop}`' )
	template( #createdAt='{ item }' ) {{dayjs(item.createdAt).format("DD-MM-YYYY")}}
	template( #orders='{ item }' ) {{item.Orders.length}}
	template( #buttons='{ item }' )
		.is-flex.is-align-items-center.is-justify-content-flex-end
			b-button( node="router-link" :to='{ name: "Client", params: { clientId: item.id } }' type="link" size="small" )
				span.icon
					i.fa-solid.fa-arrow-right
</template>

<script setup>
import BTable from "@/components/table/Table.vue"

import dayjs from "@/common/dayjs"
import { useI18n } from "vue-i18n"
import { computed } from "vue"

const props = defineProps({
	clients: Array,
	loading: Boolean,
	buttons: Boolean
})
const emit = defineEmits([ "select" ])

const { t } = useI18n()

const columns = computed(() => {
	const data = [
		{ field: "name", label: t("default.client.name") },
		{ field: "contacts", label: t("default.client.contacts") },
		{ field: "createdAt", label: t("default.client.createdAt") },
		{ field: "orders", label: t("default.client.orders") }
	]

	if (props.buttons)
		data.push({ field: "buttons" })

	return data
})

const h = phone => ({
	telegram: `https://t.me/${phone}`,
	whatsapp: `https://wa.me/${phone.replace("+", "")}`,
	viber: `viber://contact?number=${phone.replace("+", "%2B")}`
})

const s = socials => {
	const data = {
		extra: {},
		main: {}
	}
	
	if (socials) {
		for (let social of socials) {
			if (social.extra)
				data.extra[social.name] = true
			else
				data.main[social.name] = true
		}
	}

	return data
}
</script>